
extends KinematicBody2D


var playerClass = preload("res://scripts/player.gd")

var GRAVITY = 45.0
var SPEED = 20.0
var DAMPING = Vector2(0.75, 0.9)

var velocity = Vector2()
var collisionNormal = Vector2()

var direction = -1
var rl
var rr


func on_ground():
	if(collisionNormal.length() > 0):
		var floorHit = collisionNormal.dot(Vector2(0, -1)) >= 0.5
		return floorHit
	
	return false


func _ready():
	rl = get_node("RayLeft")
	rr = get_node("RayRight")
	set_fixed_process(true)


func _fixed_process(delta):
#	Choose Direction
	if direction < 0:
		if not rl.is_colliding():
			direction = -direction
		elif rl.is_colliding() and (rl.get_collision_point() - rl.get_global_pos()).y < 8:
			direction = -direction
		
	elif direction > 0:
		if not rr.is_colliding():
			direction = -direction
		elif rr.is_colliding() and (rr.get_collision_point() - rr.get_global_pos()).y < 8:
			direction = -direction
	
#	Movement
	velocity.y += GRAVITY
	velocity.x += direction * SPEED
	
	if on_ground():
		velocity.x -= collisionNormal.x * GRAVITY * (1 / sin(collisionNormal.dot(Vector2(0, -1)))) * 0.9185
	
	var motion = velocity * delta
	motion = move(motion)
	
#	Collision
	if is_colliding():
		collisionNormal = get_collision_normal()
		motion = collisionNormal.slide(motion)
		velocity = collisionNormal.slide(velocity)
		
		move(motion)
		
		set_pos(Vector2(get_pos().x, round(get_pos().y)))
		
	else:
		collisionNormal = Vector2()
	
	velocity *= DAMPING


func _on_DamageArea_body_enter( body ):
	var main = get_tree().get_root().get_node("Main")
	if main.state == main.STATE_PLAYING:
		if body extends playerClass:
			body.take_damage(5, get_global_pos())


