
extends CanvasLayer


func _ready():
	set_process(true)


func _process(delta):
	var curTime = ""
	var timeScore = get_parent().timeScore
	var timeMin = int(timeScore / 60.0)
	var timeSec = int(timeScore) % 60
	var timeMsec = floor((int(timeScore * 60.0) % 60) / 0.6)
	
	if timeMin < 10:
		timeMin = "0" + str(timeMin)
	if timeSec < 10:
		timeSec = "0" + str(timeSec)
	if timeMsec < 10:
		timeMsec = "0" + str(timeMsec)
	
	curTime = str(timeMin) + ":" + str(timeSec) + "." + str(timeMsec)
	
	get_node("Time").set_text(curTime)
	
	var player = get_parent().get_node("Player")
	if player:
		var barWidth = round((player.health / 20.0) * 128)
		
		var barRect = Rect2(0, 0, barWidth, 14)
		get_node("HealthBar/Blue").set_region_rect(barRect)
		
		var redBarWidth = max(lerp(get_node("HealthBar/Red").get_region_rect().size.width, barWidth, delta * 2), barWidth)
		var barRect = Rect2(0, 14, redBarWidth, 14)
		get_node("HealthBar/Red").set_region_rect(barRect)


