
extends CanvasLayer


var initialFocus = false


func show():
	get_node("Menu").show()
	initialFocus = false
	set_process_input(true)
	get_tree().set_pause(true)


func hide():
	get_tree().set_pause(false)
	set_process_input(false)
	get_node("Menu").hide()


func _ready():
	hide()


func _input(event):
	if not initialFocus:
		if event.is_action_pressed("ui_down") or event.is_action_pressed("ui_focus_next"):
			get_tree().set_input_as_handled()
			get_node("Menu/VBoxContainer/MenuButton").grab_focus()
			initialFocus = true
			
		elif event.is_action_pressed("ui_up") or event.is_action_pressed("ui_focus_prev"):
			get_tree().set_input_as_handled()
			get_node("Menu/VBoxContainer/ContinueButton").grab_focus()
			initialFocus = true
	
	if event.is_action_pressed("ui_cancel"):
		if get_node("Menu/VBoxContainer/MenuButton").has_focus():
			_on_MenuButton_pressed()
		get_node("Menu/VBoxContainer/MenuButton").grab_focus()
		initialFocus = true
		
	elif event.is_action_pressed("ui_pause"):
		_on_ContinueButton_pressed()


func _on_ContinueButton_pressed():
	get_parent().get_node("SamplePlayer").play("button_press")
	hide()


func _on_MenuButton_pressed():
	get_parent().get_node("SamplePlayer").play("button_press")
	hide()
	get_parent().goto_menu()


