tool
extends Node2D

export(Vector2) var movement
export(float) var speed = 1.0
export(int) var offset = 0

var cycle = 1.0
var accum = 0.0
var lastPos = Vector2()
var velocity = Vector2()

#Tool mode vars
var lastMovement = Vector2()

func _ready():
	set_fixed_process(true)
	
	if get_tree().is_editor_hint():
		lastMovement = movement
		update()
		
	else:
		offset = deg2rad(offset)
		cycle = (movement.length() / 19.2) * speed


func _fixed_process(delta):
	if get_tree().is_editor_hint():
		if movement != lastMovement:
			update()
		lastMovement = movement
		
	else:
		accum += delta * (1.0 / cycle) * PI * 2.0
		accum = fmod(accum, PI*2.0)
		var d = sin(accum + offset)
		var xf = Matrix32()
		xf[2]= movement * d
		
		get_node("Platform").set_transform(xf)
		
		velocity = get_node("Platform").get_pos() - lastPos
		lastPos = get_node("Platform").get_pos()


func _draw():
	if get_tree().is_editor_hint():
		var recPos1 = movement - Vector2(48, 8)
		draw_rect(Rect2(recPos1, Vector2(96, 16)), Color(1, 0, 0, 0.5))
		
		var recPos2 = -movement - Vector2(48, 8)
		draw_rect(Rect2(recPos2, Vector2(96, 16)), Color(1, 0, 0, 0.5))
		
		draw_line(recPos1 + Vector2(48, 8), recPos2 + Vector2(48, 8), Color(1, 0, 0, 0.5), 16)


